var isEven = n => n % 2 === 0;
var toFixed = n => Number.parseFloat(n).toFixed(2);
var radToDeg = radians => radians * 180 / Math.PI;

let getPointCoords = (x, y) => {
  let point = document.querySelector(`[data-x="${x}"][data-y="${y}"]`);

  return [point.x.baseVal.value, point.y.baseVal.value]
};

var svgns = "http://www.w3.org/2000/svg",
    svg = document.querySelector('svg'),
    rect = document.querySelector('rect#map');

var columnCount = 33,
    rowCount = 25,
    pointDistanceInInches = 1.005;

var columns = [...Array(columnCount).keys()],
    rows = [...Array(rowCount).keys()],
    points = rows.map(y => columns.map(x => [x, y]));

var xOffset = 0.25,
    yOffset = 0.45;
    calcY = Math.sqrt(3) * pointDistanceInInches / 2,
    alternatingOffset = pointDistanceInInches / 2;

rect.addEventListener('mousemove', e => {
  var rect = e.target.getBoundingClientRect();
  var x = e.clientX - rect.left;
  var y = e.clientY - rect.top;
  let [maxX, maxY] = [e.target.width, e.target.height].map(v => v.baseVal.valueInSpecifiedUnits);
  let [maxXpx, maxYpx] = [e.target.width, e.target.height].map(v => v.baseVal.value);

  // console.log('x', `${toFixed(x / rect.width * maxX)}"`, 'y', `${toFixed(y / rect.height * maxY)}"`);

  let aim = document.querySelector('.firing-arc.active');
  let p = document.querySelector('polyline.firing-arc.active');

  // TODO: handle horizontal and vertical lines

  if (aim || p) {
    let xIntercept = y => (y - y1) * (x2 - x1) / (y2 - y1) + x1;
    let yIntercept = x => (x - x1) * (y2 - y1) / (x2 - x1) + y1;
    let xInterceptPx = y => (y - y1px) * (x2px - x1px) / (y2px - y1px) + x1px;
    let yInterceptPx = x => (x - x1px) * (y2px - y1px) / (x2px - x1px) + y1px;
    let newX, newY;

    let [x1, y1] = [aim.x1, aim.y1].map(v => v.baseVal.valueInSpecifiedUnits);
    let [x2, y2] = [x / rect.width * maxX, y / rect.height * maxY];

    let {x: x1px, y: y1px} = p.points[1];
    let [x2px, y2px] = [x / rect.width * maxXpx, y / rect.height * maxYpx];

    if (x2px - x1px > 0 && y2px - y1px > 0) {
      let yWhenXisMax = yInterceptPx(maxXpx);
      let xWhenYisMax = xInterceptPx(maxYpx);

      if (xWhenYisMax <= maxXpx) {
        newX = xWhenYisMax;
        newY = maxYpx;
      } else {
        newX = maxXpx;
        newY = yWhenXisMax;
      }
    } else if (x2px - x1px > 0 && y2px - y1px < 0) {
      let yWhenXisMax = yInterceptPx(maxXpx);
      let xWhenYisZero = xInterceptPx(0);

      if (xWhenYisZero <= maxXpx) {
        newX = xWhenYisZero;
        newY = 0;
      } else {
        newX = maxXpx;
        newY = yWhenXisMax;
      }
    } else if (x2px - x1px < 0 && y2px - y1px < 0) {
      let yWhenXisZero = yInterceptPx(0);
      let xWhenYisZero = xInterceptPx(0);

      if (yWhenXisZero >= 0) {
        newX = 0;
        newY = yWhenXisZero;
      } else {
        newX = xWhenYisZero;
        newY = 0;
      }
    } else {
      let yWhenXisZero = yInterceptPx(0);
      let xWhenYisMax = xInterceptPx(maxYpx);

      if (yWhenXisZero <= maxYpx) {
        newX = 0;
        newY = yWhenXisZero;
      } else {
        newX = xWhenYisMax;
        newY = maxYpx;
      }
    }


    let slope = (y2px - y1px) / (x2px - x1px);
    let inverseSlope = -1 / slope;

    console.log('slope', slope);
    console.log('inverse slope', inverseSlope);

    let smlArcAngle = Math.atan(pointDistanceInInches / (6 * calcY)) * 2;
    let distance = Math.sqrt((x2px - x1px)**2 + (y2px - y1px)**2);
    let newY1 = y2px + distance * Math.atan(smlArcAngle / 2);
    let newY2 = y2px - distance * Math.atan(smlArcAngle / 2);

    // p.setAttributeNS(null, 'points', `${newX},${newY} ${x1px},${y1px} ${newX},${newY}`);
    // p.setAttributeNS(null, 'points', `${x2px},${y2px} ${x1px},${y1px} ${x2px},${y2px}`);
    p.setAttributeNS(null, 'points', `${x2px},${newY1} ${x1px},${y1px} ${x2px},${newY2}`);

    console.log(p);

    if (x2 - x1 > 0 && y2 - y1 > 0) {
      let yWhenXisMax = yIntercept(maxX);
      let xWhenYisMax = xIntercept(maxY);

      if (xWhenYisMax <= maxX) {
        newX = xWhenYisMax;
        newY = maxY;
      } else {
        newX = maxX;
        newY = yWhenXisMax;
      }
    } else if (x2 - x1 > 0 && y2 - y1 < 0) {
      let yWhenXisMax = yIntercept(maxX);
      let xWhenYisZero = xIntercept(0);

      if (xWhenYisZero <= maxX) {
        newX = xWhenYisZero;
        newY = 0;
      } else {
        newX = maxX;
        newY = yWhenXisMax;
      }
    } else if (x2 - x1 < 0 && y2 - y1 < 0) {
      let yWhenXisZero = yIntercept(0);
      let xWhenYisZero = xIntercept(0);

      if (yWhenXisZero >= 0) {
        newX = 0;
        newY = yWhenXisZero;
      } else {
        newX = xWhenYisZero;
        newY = 0;
      }
    } else {
      let yWhenXisZero = yIntercept(0);
      let xWhenYisMax = xIntercept(maxY);

      if (yWhenXisZero <= maxY) {
        newX = 0;
        newY = yWhenXisZero;
      } else {
        newX = xWhenYisMax;
        newY = maxY;
      }
    }

    aim.setAttributeNS(null, 'x2', `${newX}in`);
    aim.setAttributeNS(null, 'y2', `${newY}in`);

    let width = aim.x2.baseVal.value - aim.x1.baseVal.value;
    let height = -(aim.y2.baseVal.value - aim.y1.baseVal.value);
    let angle = Math.abs(radToDeg(Math.atan(height / width)));

    if (width < 0 && height > 0) {
      angle = 180 - angle;
    } else if (width < 0 && height < 0) {
      angle = 180 + angle;
    } else if (width > 0 && height < 0) {
      angle = 360 - angle;
    }

    console.log(`${toFixed(angle)}\u00B0`);
  }
});

document.querySelectorAll('.soldier-record').forEach(el =>
  el.addEventListener('click', e => {
    if (e.target.classList.contains('selected')) {
      e.target.classList.remove('selected');
    } else {
      document.querySelectorAll('.soldier-record.selected').forEach(el =>
        el.classList.remove('selected')
      );
      e.target.classList.add('selected');
    }
  })
);

document.querySelector('#set-firing-arc').addEventListener('click', e => {
  let selectedSoldier = document.querySelector('.soldier-record.selected');

  if (selectedSoldier) {
    let {troopNumber, troopAllegiance} = selectedSoldier.dataset;

    let existingArc = document.querySelector(
      `.firing-arc[data-troop-number="${troopNumber}"][data-troop-allegiance="${troopAllegiance}"]`
    );

    if (existingArc) { existingArc.remove() }

    let counter = document.querySelector(
      `circle.counter[data-troop-number="${troopNumber}"][data-troop-allegiance="${troopAllegiance}"]`
    );

    let aim = document.createElementNS(svgns, 'line');

    aim.classList.add('firing-arc', 'active');
    aim.dataset.troopNumber = troopNumber;
    aim.dataset.troopAllegiance = troopAllegiance;
    aim.setAttributeNS(null, 'x1', counter.cx.baseVal.valueAsString);
    aim.setAttributeNS(null, 'y1', counter.cy.baseVal.valueAsString);
    aim.setAttributeNS(null, 'x2', counter.cx.baseVal.valueAsString);
    aim.setAttributeNS(null, 'y2', counter.cy.baseVal.valueAsString);
    // aim.style.transformOrigin = `${counter.cx.baseVal.valueAsString} ${counter.cy.baseVal.valueAsString}`;

    svg.appendChild(aim);

    aim.addEventListener('click', e => {
      e.target.classList.remove('active');
      document.querySelector('circle#point').style.display = '';
    });

    let pivotPoint = [counter.cx.baseVal.value, counter.cy.baseVal.value];
    let firingArc = document.createElementNS(svgns, 'polyline');
    firingArc.classList.add('firing-arc', 'active');
    firingArc.dataset.troopNumber = troopNumber;
    firingArc.dataset.troopAllegiance = troopAllegiance;
    firingArc.setAttributeNS(null, 'points', `${pivotPoint} ${pivotPoint} ${pivotPoint}`);

    svg.appendChild(firingArc);

    document.querySelector('circle#point').style.display = 'none';
  }
});

points.forEach((row, index) => row.forEach(([x, y]) => {
  var cx = x * pointDistanceInInches + xOffset + (isEven(index) ? alternatingOffset : 0),
      cy = y * pointDistanceInInches * calcY + yOffset,
      point = document.createElementNS(svgns, 'use');

  point.setAttributeNS(null, 'href', `#point`);
  point.setAttributeNS(null, 'x', `${cx}in`);
  point.setAttributeNS(null, 'y', `${cy}in`);
  point.dataset.x = x;
  point.dataset.y = y;

  point.addEventListener('click', e => {
    let selectedSoldier = document.querySelector('.soldier-record.selected');

    if (selectedSoldier) {
      let counter = document.createElementNS(svgns, 'circle');
      let text = document.createElementNS(svgns, 'text');

      counter.setAttributeNS(null, 'cx', `${cx}in`);
      counter.setAttributeNS(null, 'cy', `${cy}in`);
      counter.setAttributeNS(null, 'r', '0.25in');
      counter.dataset.troopNumber = selectedSoldier.dataset.troopNumber;
      counter.dataset.troopAllegiance = selectedSoldier.dataset.troopAllegiance;
      counter.classList.add('counter');

      text.setAttributeNS(null, 'text-anchor', 'middle');
      text.setAttributeNS(null, 'x', `${cx}in`);
      text.setAttributeNS(null, 'y', `${cy + 0.25}in`);
      text.dataset.troopNumber = selectedSoldier.dataset.troopNumber;
      text.dataset.troopAllegiance = selectedSoldier.dataset.troopAllegiance;
      text.textContent = `${selectedSoldier.dataset.troopNumber}`;
      text.classList.add('counter');

      document.querySelectorAll(
        `.counter[data-troop-number="${selectedSoldier.dataset.troopNumber}"][data-troop-allegiance="${selectedSoldier.dataset.troopAllegiance}"]`
      ).forEach(el => el.remove());

      svg.appendChild(counter);
      svg.appendChild(text);
    }
  });

  svg.appendChild(point);
}));

let smlArc = document.createElementNS(svgns, 'polygon');
smlArc.setAttributeNS(null, 'id', 'small-arc');
let smlArcPoints = `${getPointCoords(1, 24)} ${getPointCoords(1, 21)} ${getPointCoords(2, 21)}`;
smlArc.setAttributeNS(null, 'points', smlArcPoints);

svg.appendChild(smlArc);

let medArc = document.createElementNS(svgns, 'polygon');
medArc.setAttributeNS(null, 'id', 'med-arc');
let medArcPoints = `${getPointCoords(4, 24)} ${getPointCoords(3, 21)} ${getPointCoords(6, 21)}`;
medArc.setAttributeNS(null, 'points', medArcPoints);

svg.appendChild(medArc);

let lrgArc = document.createElementNS(svgns, 'polygon');
lrgArc.setAttributeNS(null, 'id', 'lrg-arc');
let lrgArcPoints = `${getPointCoords(19, 24)} ${getPointCoords(9, 21)} ${getPointCoords(30, 21)}`;
lrgArc.setAttributeNS(null, 'points', lrgArcPoints);

svg.appendChild(lrgArc);

// arc = document.querySelector('#med-arc');
// let [ox, oy] = getPointCoords(4, 24);
// arc.style.transformOrigin = `${ox}px ${oy}px`;
// arc.style.transform = 'rotate(90deg)';

var smlArcAngle = radToDeg((Math.atan(pointDistanceInInches / (6 * calcY)) * 2));
var medArcAngle = radToDeg((Math.atan((3 * pointDistanceInInches) / (6 * calcY)) * 2));
var lrgArcAngle = radToDeg((Math.atan((21 * pointDistanceInInches) / (6 * calcY)) * 2));